//+------------------------------------------------------------------+
//|                                                         9-30.mq4 |
//|                                                   Dan Buffington |
//|                                         buffington.dan@gmail.com |
//| this indicator is based on the "Floor Trader" method described on|
//| this page:        http://www.trading-naked.com/mb-9-30-setup.htm |
//+------------------------------------------------------------------+
#property copyright "Dan Buffington"
#property link      "buffington.dan@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2

//---- input parameters
extern bool      showAlert = true;
extern int       BarsToCount  =  100;
extern int       EMA=9;
extern int       LWMA=30;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

string prefix = "9-30v1";

double long[];
double short[];


int init()
  {
//---- arrows
   SetIndexStyle(0,DRAW_ARROW,0,0,Green); 
   SetIndexArrow(0,224);//(234 down arrow), 70(finger), 224(side arrow)
   SetIndexBuffer(0,long); 
   SetIndexEmptyValue(0,0);
   SetIndexLabel(0,"Long Here");
   
   SetIndexStyle(1,DRAW_ARROW,0,0,Red); 
   SetIndexArrow(1,224);//(234 down arrow), 70(finger), 224(side arrow)
   SetIndexBuffer(1,short); 
   SetIndexEmptyValue(1,0);
   SetIndexLabel(1,"Short Here");
   

   

   
//----


   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   clearScreen(prefix,true,NULL);
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();

   if (counted_bars < 0) {
      return(-1);
   } else {
      counted_bars--;
   }
   int i, limit = Bars - counted_bars;

//----    
   for (i=1; i<=BarsToCount; i++) {
         
         double ema9 =  iMA(NULL,0,EMA,0,MODE_EMA,0,i);
         double Lwma30  =  iMA(NULL,0,LWMA,0,MODE_LWMA,0,i);

         
     
   if /*one bar cross down*/((ema9 > Lwma30) && (Open[i] > ema9) && (Close[i] < ema9))
   
   {//do this
   long[i] = High[i] + 0.0003;
   if (showAlert != true){Print(Symbol()," - One bar EMA cross DOWN. ");} 
   if (showAlert != false){Alert(Symbol()," - One bar EMA cross DOWN. ");} 
   }
   
   else if /*2 bar cross down*/ ((ema9 > Lwma30) && (Open[i] > ema9) && (Close[i+1] < ema9))
   {//do this
   long[i] = High[i] + 0.0003;
   
   if (showAlert != true) {Print(Symbol()," - Two bar EMA cross DOWN. ");}   
   if (showAlert != false){Alert(Symbol()," - Two bar EMA cross DOWN. ");}   
   }
      
   else if((ema9 < Lwma30) && (Open[i] < ema9) && (Close[i] > ema9))
   
   {//do this instead
   short[i]   =  Low[i] - 0.0003;  

   if (showAlert != true) {Print(Symbol()," - One bar EMA cross UP. ");}
   if (showAlert != false){Alert(Symbol()," - One bar EMA cross UP. ");}
   }
   
   else if /*2 bar cross down*/((ema9 < Lwma30) && (Open[i] < ema9) && (Close[i+1] > ema9))
   {//do this instead
   short[i]   =  Low[i] - 0.0003;  

   if (showAlert != true){Print(Symbol(),"  - Two bar EMA cross DOWN. ");}
   if (showAlert != false){Alert(Symbol(),"  - Two bar EMA cross DOWN. ");}
   }   
   
   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
void clearScreen(string prefix, bool clearComments, string exception)
{  
   if (clearComments) Comment("");
  
   int objectstotal = ObjectsTotal();
   string name = "";

   for (int i = objectstotal; i >= 0; i--) {
    
     name = ObjectName(i);
    
     if (StringFind(name,prefix,0) > -1 && StringFind(name,exception,0) == -1) ObjectDelete(name);
    
   }
   }